unit KolProcessMapper;

interface

uses Windows;

procedure ProcessCreateSnapshot;
procedure ProcessDeleteSnapshot;
function ProcessPIDToProcessName(PID: DWord): string;

implementation

uses Kol, TLHelp32;

var
  ProcessSnapshot: THandle;

procedure ProcessCreateSnapshot;
begin
  // If we've already got a snapshot, ditch it
  if ProcessSnapShot <> 0 then ProcessDeleteSnapshot;
  ProcessSnapshot := CreateToolhelp32Snapshot(TH32CS_SnapProcess, 0);
end;

procedure ProcessDeleteSnapshot;
begin
  if ProcessSnapShot <> 0 then CloseHandle(ProcessSnapShot);
  ProcessSnapShot := 0;
end;

function ProcessPIDToProcessName(PID: DWord): string;
var
  OK: boolean;
  ProcEntry: TProcessEntry32;
begin
  if ProcessSnapShot = 0 then Result := Int2Str(PID) 
  else 
  begin
    Result := '-unknown-';
    Ok := Process32First(ProcessSnapShot, ProcEntry);
    while Ok do 
    begin
      if ProcEntry.th32ProcessID = PID then 
      begin
        Result := ProcEntry.szExeFile;
        Exit;
      end;
      Ok := Process32Next(ProcessSnapShot, ProcEntry);
    end;
  end;
end;

initialization
  ProcessSnapShot := 0;

finalization
  ProcessDeleteSnapshot;
end.

