unit netstat;
  //********************************************************************
  //  Created by KOL project Expert Version 2.00 on:12-9-2003 10:25:57
  //********************************************************************


interface

uses
  Windows, Messages, Kol, kolnetworkinfo;

type

  PForm1 = ^TForm1;
  TForm1 = object(Tobj)
    Form: pControl;
    Info: pNetworkInfo;
    StatsTimer: PTimer;
    AdapterView,
    Pagecontrol,
    StatsTab,
    ConnectsTab,
    TcpConnects,
    UDPconnects,
    pnl1,
    IPaddress,
    Subnetmask,
    Adaptertype,
    DefaultGateway,
    btnPanel,
    RefreshBtn,
    CheckBox1,
    Forwarding,
    DefaultTTL,
    DatagramsReceived,
    ReceivedHeaderErrors,
    ReceivedAddressErrors,
    ForwardedDatagrams,
    UnknownProtocols,
    ReceivedDiscardCount,
    ReceivedDeliveredCount,
    SentDatagramsCount,
    RoutingDiscards,
    SetDatagramsDiscarded,
    NoRouteDatagrams,
    ReassembleTimeoutCount,
    ReassemblyRequiredCount,
    OKReassemblies,
    BadReassemblies,
    OKFragmentations,
    BadFragmentations,
    FragmentationsCount,
    NumInterfaces,
    NumAddresses,
    NumRoutes,
    TimeoutAlgo,
    MinTimeout,
    MaxTimeout,
    MaxConnections,
    ActiveOpens,
    PassiveOpens,
    FailedConnects,
    ResetConnects,
    CurrentConnects,
    ReceivedSegments,
    SentSegments,
    ResentSegments,
    ErrorsReceived,
    SentSegsReset,
    CumulativeConnects,
    GroupBox1,
    Groupbox2,
    DHCPServer,
    DHCPStart,
    DHCPend,
    PrimaryWINSserver,
    SecondaryWINSserver,
    gp1,
    gp2: PControl;
  private
    { Private declarations }
  public
    procedure RefreshTCPConnectionsView;
    procedure RefreshUDPConnectionsView;
    function DoMessage(var Msg: Tmsg; var Rslt: integer): boolean;
    procedure AdapterViewSelectItem(Sender: PObj);
    procedure StatsTimerTimer(Sender: PObj);
    procedure RefreshBtnClick(Sender: PObj);
    procedure CheckBox1Click(Sender: PObj);
  end;


procedure NewForm1(var Result: PForm1; AParent: PControl);

var
  Form1: pForm1;

implementation

procedure NewForm1(var Result: PForm1; AParent: PControl);
const
  NY: array [boolean] of string = ('No', 'Yes');
var
  idx: integer;
  Adapter: PNetworkAdapter;
begin
  New(Result, Create);
  with Result^ do
  begin
    Form := NewForm(AParent, 'Thaddy''s Netstat').SetSize(740,330).centeronparent.Tabulate;
    Applet := Form;
    Form.OnMessage := DoMessage;
    Form.Add2AutoFree(Result);
    form.Font.fontheight := -12;
    Pagecontrol := NewTabControl(form, ['Network Adapters',
      'Network Statistics', 'Network Connections'], [tcoFlat], nil, 0).setalign(caClient);
    pnl1 := NewPanel(Pagecontrol.Pages[0], esNone).SetAlign(caBottom);
    pnl1.Margin := 2;
    GroupBox1 := NewGroupBox(Pnl1, 'DHCP').setposition(232,10).setsize(235,73);
    Newlabel(Groupbox1, 'DHCP Server:').AutoSize(True).SetPosition(10,20);
    Newlabel(Groupbox1, 'DHCP Start:').AutoSize(True).PlaceUnder;
    Newlabel(Groupbox1, 'DHCP End:').AutoSize(True).PlaceUnder;
    Groupbox1.Font.fontstyle := [fsBold];
    DhcpServer := NewLabel(Groupbox1, '-').AutoSize(True).SetPosition(100,20);
    DhcpStart := NewLabel(Groupbox1, '-').AutoSize(True).PlaceUnder;
    DhcpEnd := NewLabel(Groupbox1, '-').AutoSize(True).PlaceUnder;
    GroupBox2 := NewGroupBox(Pnl1, 'WINS').PlaceRight.setsize(235,73);
    Newlabel(Groupbox2, 'Primary Server:').AutoSize(True).SetPosition(10,20);
    Newlabel(Groupbox2, 'Secondary Server').AutoSize(True).PlaceUnder;
    Groupbox2.Font.fontstyle := [fsBold];
    PrimaryWinsServer := NewLabel(GroupBox2,
      '-').AutoSize(True).SetPosition(100,20);
    SecondaryWinsServer := NewLabel(GroupBox2, '-').AutoSize(True).PlaceUnder;
    AdapterView := NewListView(Pagecontrol.Pages[0], lvsDetail,
      [lvoRowselect], nil, nil, nil).setalign(caClient);
    Adapterview.LVColAdd('Description', taLeft, 250);
    Adapterview.LVColAdd('Driver Name', taLeft, 200);
    Adapterview.LVColAdd('MAC Address', taLeft, 100);
    Adapterview.LVColAdd('Index', taLeft, 50);
    Adapterview.LVColAdd('DHCP', taLeft, 50);
    Adapterview.LVColAdd('WINS', taLeft, 50);
    Adapterview.OnClick := AdapterviewselectItem;
    Info := Newnetworkinfo(Form);
    for Idx := 0 to Info.Adapters.Count - 1 do
    begin
      Adapter := Info.Adapters.Items[Idx];
      Adapterview.LVItemAdd(Adapter.description);
      Adapterview.LVItemData[idx] := cardinal(Adapter);
      Adapterview.LVItems[idx, 1] := Adapter.DriverName;
      Adapterview.LVItems[idx, 2] := Adapter.macaddress;
      Adapterview.LVItems[idx, 3] := int2str(Adapter.index);
      Adapterview.LVItems[idx, 4] := NY[Adapter.DHCPenabled];
      Adapterview.LVItems[idx, 5] := NY[Adapter.HaveWINS];
    end;
    StatsTab := NewTabControl(PageControl.Pages[1], ['IP Stats', 'TCP Stats'],
      [tcoFlat, tcoBottom], nil, 0).setalign(caClient);
    Statstab.Margin := 2;

    ConnectsTab := NewTabControl(PageControl.Pages[2],
      ['TCP Connects', 'UDP Connects'], [tcoFlat, tcoBottom], nil, 0).setalign(caClient);
    BtnPanel := NewPanel(PageControl.Pages[2], esNone).Setalign(caBottom);
    RefreshBtn := NewButton(BtnPanel, 'Refresh').ResizeParent;
    RefreshBtn.OnClick := RefreshBtnClick;
    CheckBox1 := NewCheckBox(BtnPanel, 'Show process names').PlaceRight.AutoSize(True);
    CheckBox1.OnClick := Checkbox1Click;
    TcpConnects := NewlistView(ConnectsTab.Pages[0], lvsDetail, [], nil,
      nil, nil).setalign(caClient);
    TcpConnects.LVColAdd('State', taLeft, 100);
    TcpConnects.LVColAdd('Local Address', taLeft, 100);
    TcpConnects.LVColAdd('Local Port', taLeft, 100);
    TcpConnects.LVColAdd('Remote Address', taLeft, 100);
    TcpConnects.LVColAdd('Remote Port', taLeft, 100);
    TcpConnects.LVColAdd('Process', taLeft, 200);
    UDPConnects := NewlistView(ConnectsTab.Pages[1], lvsDetail, [], nil,
      nil, nil).setalign(caClient);
    UDPConnects.LVColAdd('Local Address', taLeft, 100);
    UDPConnects.LVColAdd('Local Port', taLeft, 100);
    UDPConnects.LVColAdd('Process', taLeft, 200);
    RefreshTCPConnectionsView;
    RefreshUDPConnectionsView;
    AdapterView.LVItemstate[0] := [lvIsSelect];
    StatsTimer := NewTimer(100);
    StatsTimer.OnTimer := StatsTimertimer;
    form.Add2AutoFree(StatsTimer);
    Gp1 := NewGroupbox(Statstab.pages[0], '').setalign(caClient);
    Gp1.Margin := 3;
    Newlabel(Gp1, 'Forwarding').AutoSize(True).setposition(20,20);
    Newlabel(Gp1, 'Default TTL').AutoSize(True).PlaceUnder;
    Newlabel(Gp1, 'Datagrams Received').AutoSize(True).PlaceUnder;
    Newlabel(Gp1, 'Received Header Errors').AutoSize(True).PlaceUnder;
    Newlabel(Gp1, 'Received Address Errors').AutoSize(True).PlaceUnder;
    Newlabel(Gp1, 'Forwarded Datagrams').AutoSize(True).PlaceUnder;
    Newlabel(Gp1, 'Unknown Protocols').AutoSize(True).PlaceUnder;
    Newlabel(Gp1, 'Received Discard Count').AutoSize(True).PlaceUnder;
    Newlabel(Gp1, 'Received Delivered Count').AutoSize(True).PlaceUnder;
    Newlabel(Gp1, 'Sent Datagrams Count').AutoSize(True).PlaceUnder;
    Newlabel(Gp1, 'Routing Discards').AutoSize(True).PlaceUnder;
    Newlabel(Gp1, 'Set Datagrams Discarded').AutoSize(True).PlaceUnder;
    Newlabel(Gp1, 'No Route Datagrams').AutoSize(True).Setposition(400,20);
    Newlabel(Gp1, 'Reassemble Timeout Count').AutoSize(True).PlaceUnder;
    Newlabel(Gp1, 'Reassembly Required Count').AutoSize(True).PlaceUnder;
    Newlabel(Gp1, 'OK Reassemblies').AutoSize(True).PlaceUnder;
    Newlabel(Gp1, 'Bad Reassemblies').AutoSize(True).PlaceUnder;
    Newlabel(Gp1, 'OK Fragmentations').AutoSize(True).PlaceUnder;
    Newlabel(Gp1, 'Bad Fragmentations').AutoSize(True).PlaceUnder;
    Newlabel(Gp1, 'Fragmentations Count').AutoSize(True).PlaceUnder;
    Newlabel(Gp1, 'Num Interfaces').AutoSize(True).PlaceUnder;
    Newlabel(Gp1, 'Num Addresses').AutoSize(True).PlaceUnder;
    Newlabel(Gp1, 'Num Routes').AutoSize(True).PlaceUnder;
    Gp1.Font.fontstyle := [fsBold];
    Forwarding := Newlabel(Gp1, '-').AutoSize(True).setposition(250,20);
    //Forwarding.Left := 200;
    DefaultTTL := Newlabel(Gp1, '-').AutoSize(True).PlaceUnder;
    DatagramsReceived := Newlabel(Gp1,
      '-').AutoSize(True).PlaceUnder;
    ReceivedHeaderErrors := Newlabel(Gp1,
      '-').AutoSize(True).PlaceUnder;
    ReceivedAddressErrors := Newlabel(Gp1,
      '-').AutoSize(True).PlaceUnder;
    ForwardedDatagrams := Newlabel(Gp1,
      '-').AutoSize(True).PlaceUnder;
    UnknownProtocols := Newlabel(Gp1, '-').AutoSize(True).PlaceUnder;
    ReceivedDiscardCount := Newlabel(Gp1,
      '-').AutoSize(True).PlaceUnder;
    ReceivedDeliveredCount := Newlabel(Gp1,
      '-').AutoSize(True).PlaceUnder;
    SentDatagramsCount := Newlabel(Gp1,
      '-').AutoSize(True).PlaceUnder;
    RoutingDiscards := Newlabel(Gp1, '-').AutoSize(True).PlaceUnder;
    SetDatagramsDiscarded := Newlabel(Gp1,
      '-').AutoSize(True).PlaceUnder;
    NoRouteDatagrams := Newlabel(Gp1,
      '-').AutoSize(True).setposition(600,20);
    ReassembleTimeoutCount := Newlabel(Gp1,
      '-').AutoSize(True).PlaceUnder;
    ReassemblyRequiredCount := Newlabel(Gp1,
      '-').AutoSize(True).PlaceUnder;
    OKReassemblies := Newlabel(Gp1, '-').AutoSize(True).PlaceUnder;
    BadReassemblies := Newlabel(Gp1, '-').AutoSize(True).PlaceUnder;
    OKFragmentations := Newlabel(Gp1, '-').AutoSize(True).PlaceUnder;
    BadFragmentations := Newlabel(Gp1,
      '-').AutoSize(True).PlaceUnder;
    FragmentationsCount := Newlabel(Gp1,
      '-').AutoSize(True).PlaceUnder;
    NumInterfaces := Newlabel(Gp1, '-').AutoSize(True).PlaceUnder;
    NumAddresses := Newlabel(Gp1, '-').AutoSize(True).PlaceUnder;
    NumRoutes := Newlabel(Gp1, '-').AutoSize(True).PlaceUnder;
    gp2 := NewGroupBox(Statstab.pages[1], '').setalign(caClient);
    gp2.Margin := 3;
    NewLabel(Gp2, 'Timeout Algorithm').AutoSize(True).setposition(20,20);
    NewLabel(Gp2, 'Min Timeout').PlaceUnder.AutoSize(True);
    NewLabel(Gp2, 'Max Timeout').PlaceUnder.AutoSize(True);
    NewLabel(Gp2, 'Max Connections').PlaceUnder.AutoSize(True);
    NewLabel(Gp2, 'Active Opens').PlaceUnder.AutoSize(True);
    NewLabel(Gp2, 'Passive Opens').PlaceUnder.AutoSize(True);
    NewLabel(Gp2, 'Failed Connects').PlaceUnder.AutoSize(True);
    NewLabel(Gp2, 'Reset Connects').PlaceUnder.AutoSize(True);
    NewLabel(Gp2, 'Current Connects').PlaceUnder.AutoSize(True);
    NewLabel(Gp2, 'Received Segments').PlaceUnder.AutoSize(True);
    NewLabel(Gp2, 'Sent Segments').PlaceUnder.AutoSize(True);
    NewLabel(Gp2, 'Resent Segments').PlaceUnder.AutoSize(True);
    NewLabel(Gp2, 'Errors Received').setposition(400,20).AutoSize(True);
    NewLabel(Gp2, 'Sent Segments Reset').PlaceUnder.AutoSize(True);
    NewLabel(Gp2, 'Cumulative Connects').PlaceUnder.AutoSize(True);
    Gp2.Font.FontStyle := [fsBold];
    TimeoutAlgo := NewLabel(Gp2,
      '        ').AutoSize(True).SetPosition(250,20);
    MinTimeout := NewLabel(Gp2, '-').AutoSize(True).PlaceUnder;
    MaxTimeout := NewLabel(Gp2, '-').AutoSize(True).PlaceUnder;
    MaxConnections := NewLabel(Gp2, '-').AutoSize(True).PlaceUnder;
    ActiveOpens := NewLabel(Gp2, '-').AutoSize(True).PlaceUnder;
    PassiveOpens := NewLabel(Gp2, '-').AutoSize(True).PlaceUnder;
    FailedConnects := NewLabel(Gp2, '-').AutoSize(True).PlaceUnder;
    ResetConnects := NewLabel(Gp2, '-').AutoSize(True).PlaceUnder;
    CurrentConnects := NewLabel(Gp2, '-').AutoSize(True).PlaceUnder;
    ReceivedSegments := NewLabel(Gp2, '-').AutoSize(True).PlaceUnder;
    SentSegments := NewLabel(Gp2, '-').AutoSize(True).PlaceUnder;
    ResentSegments := NewLabel(Gp2, '-').AutoSize(True).PlaceUnder;
    ErrorsReceived := NewLabel(Gp2,
      '-').AutoSize(True).setposition(600,20);
    SentSegsReset := NewLabel(Gp2, '-').AutoSize(True).PlaceUnder;
    CumulativeConnects := NewLabel(Gp2, '-').AutoSize(True).PlaceUnder;
    statstimer.Enabled := True;
    newlabel(Pnl1, 'IP Address:').setposition(10,15).Autosize(True);
    newlabel(pnl1, 'Subnet Mask:').Autosize(True).PlaceUnder;
    newlabel(Pnl1, 'Adapter Type:').Autosize(True).placeUnder;
    newlabel(pnl1, 'Default Gateway:').Autosize(True).PlaceUnder;
    Pnl1.Font.FontStyle := [fsBold];
    IPAddress := newlabel(Pnl1, '-').Autosize(True).setposition(112,15);;
    SubnetMask := newlabel(pnl1, '-').Autosize(True).PlaceUnder;
    AdapterType := newlabel(Pnl1, '-').Autosize(True).placeUnder;
    DefaultGateway := newlabel(pnl1, '-').Autosize(True).PlaceUnder;
    AdapterViewSelectItem(Form);
  end;
end;


function TForm1.DoMessage(var Msg: TMsg; var Rslt: integer): boolean;
begin
  Result := False;
end;

procedure TForm1.AdapterViewSelectItem(Sender: PObj);
const
  AdapterTypeNames: array [TNetworkAdapterType] of
    string = ('Other', 'Ethernet', 'TokenRing', 'FDDI', 'PPP', 'LoopBack', 'SLIP');
var 
  Adapter: PNetworkAdapter;
begin
  //For the case of dynamic - dial up - adapters, re-initialize, tdk
  info.ClearAdapters;
  info.InitAdapters;
  if adapterview.Count = 0 then exit;
  Adapter := pNetworkAdapter(Adapterview.lvItemdata[Adapterview.LvCurItem]);
  if Adapter <> nil then
  begin
    IPAddress.Caption := Adapter.IPAddresses.items[0];
    SubNetMask.Caption := Adapter.IPMasks.items[0];
    AdapterType.Caption := AdapterTypeNames[Adapter.AdapterType];
    DefaultGateway.Caption := Adapter.DefaultGateway;
    if DefaultGateway.Caption = '' then DefaultGateway.Caption := '-none-';

    if Adapter.DHCPEnabled then 
    begin
      DHCPServer.Enabled := True;
      DHCPServer.Caption := Adapter.DHCPServerAddress;
      DHCPStart.Enabled := True;
      DHCPStart.Caption := DateTime2StrShort(Adapter.DHCPStartLease);
      DHCPEnd.Enabled := True;
      DHCPEnd.Caption := DateTime2StrShort(Adapter.DHCPEndLease);
    end
    else 
    begin
      DHCPServer.Enabled := False;
      DHCPServer.Caption := '-none-';
      DHCPStart.Enabled := False;
      DHCPStart.Caption := '-none-';
      DHCPEnd.Enabled := False;
      DHCPEnd.Caption := '-none-';
    end;

    if Adapter.HaveWINS then 
    begin
      PrimaryWINSServer.Enabled := True;
      PrimaryWINSServer.Caption := Adapter.PrimaryWINSServer;
      SecondaryWINSServer.Enabled := True;
      SecondaryWINSServer.Caption := Adapter.SecondaryWINSServer;
    end 
    else 
    begin
      PrimaryWINSServer.Enabled := False;
      PrimaryWINSServer.Caption := '-none-';
      SecondaryWINSServer.Enabled := False;
      SecondaryWINSServer.Caption := '-none-';
    end;
  end;
end;


procedure TForm1.RefreshTCPConnectionsView;
const 
  TCPStateNames: array [1..12] of string = ('Closed', 'Listening',
    'Syn Sent', 'Syn Rcvd', 'Established', 'Fin Wait1',
    'Fin Wait2', 'Close Wait', 'Closing', 'Last_Ack', 'Time Wait', 'Delete TCB');
var 
  S: string;
  Idx: integer;

  function NextField: string;
  var 
    P: integer;
  begin
    P := Pos('|', S);
    if P = 0 then P := MaxInt;
    Result := Copy(S, 1, P - 1);
    Delete(S, 1, P);
  end;
begin
  TCPConnects.Clear;
  Info.RefreshTCPConnections;
  for Idx := 0 to Info.TCPConnections.Count - 1 do 
  begin
    S := Info.TCPConnections.Items[Idx];
    TCPConnects.LvItemAdd(TCPStateNames[Str2Int(NextField)]);
    TcpConnects.LVItems[idx, 1] := NextField;
    TcpConnects.LVItems[idx, 2] := NextField;
    TcpConnects.LVItems[idx, 3] := NextField;
    TcpConnects.LVItems[idx, 4] := NextField;
    TcpConnects.LVItems[idx, 5] := NextField;
    TcpConnects.LVItems[idx, 6] := NextField;
  end;
end;

procedure TForm1.RefreshUDPConnectionsView;
var 
  S: string;
  Idx: integer;

  function NextField: string;
  var 
    P: integer;
  begin
    P := Pos('|', S);
    if P = 0 then P := MaxInt;
    Result := Copy(S, 1, P - 1);
    Delete(S, 1, P);
  end;
begin
  UDPConnects.Clear;
  Info.RefreshUDPConnections;
  for Idx := 0 to Info.UDPConnections.Count - 1 do 
  begin
    S := Info.UDPConnections.items[Idx];
    UDPConnects.LvItemAdd(Nextfield);
    UDPConnects.LvItems[idx, 1] := NextField;
    UDPConnects.LvItems[idx, 2] := NextField;
  end;
end;

procedure TForm1.RefreshBtnClick(Sender: PObj);
var 
  TabName: string;
begin
  TabName := ConnectsTab.tc_items[ConnectsTab.CurIndex];
  if TabName = 'TCP Connects' then RefreshTCPConnectionsView;
  if TabName = 'UDP Connects' then RefreshUDPConnectionsView;
end;

procedure TForm1.CheckBox1Click(Sender: PObj);
begin
  Info.MapProcessIDs := CheckBox1.Checked;
  RefreshTCPConnectionsView;
  RefreshUDPConnectionsView;
end;



procedure TForm1.StatsTimerTimer(Sender: Pobj);
var 
  TabName: string;
begin
  TabName := StatsTab.TC_items[StatsTab.CurIndex];
  Info.RefreshStatistics;

  if TabName = 'IP Stats' then with Info.IPStatistics^ do 
    begin
      Forwarding.Caption := Int2Str(IPForwarding);
      DefaultTTL.Caption := Int2Str(IPDefaultTTL);
      DatagramsReceived.Caption := Int2Str(IPDatagramsReceived);
      ReceivedHeaderErrors.Caption := Int2Str(IPReceivedHeaderErrors);
      ReceivedAddressErrors.Caption := Int2Str(IPReceivedAddressErrors);
      ForwardedDatagrams.Caption := Int2Str(IPForwardedDatagrams);
      UnknownProtocols.Caption := Int2Str(IPUnknownProtocols);
      ReceivedDiscardCount.Caption := Int2Str(IPReceivedDiscardCount);
      ReceivedDeliveredCount.Caption := Int2Str(IPReceivedDeliveredCount);
      SentDatagramsCount.Caption := Int2Str(IPSentDatagramsCount);
      RoutingDiscards.Caption := Int2Str(IPRoutingDiscards);
      SetDatagramsDiscarded.Caption := Int2Str(IPSetDatagramsDiscarded);
      NoRouteDatagrams.Caption := Int2Str(IPNoRouteDatagrams);
      ReassembleTimeoutCount.Caption := Int2Str(IPReassembleTimeoutCount);
      ReassemblyRequiredCount.Caption := Int2Str(IPReassemblyRequiredCount);
      OKReassemblies.Caption := Int2Str(IPOKReassemblies);
      BadReassemblies.Caption := Int2Str(IPBadReassemblies);
      OKFragmentations.Caption := Int2Str(IPOKFragmentations);
      BadFragmentations.Caption := Int2Str(IPBadFragmentations);
      FragmentationsCount.Caption := Int2Str(IPFragmentationsCount);
      NumInterfaces.Caption := Int2Str(IPNumInterfaces);
      NumAddresses.Caption := Int2Str(IPNumAddresses);
      NumRoutes.Caption := Int2Str(IPNumRoutes);
    end;

  if TabName = 'TCP Stats' then with Info.TCPStatistics^ do 
    begin
      TimeoutAlgo.Caption := Int2Str(TCPTimeoutAlgo);
      MinTimeout.Caption := Int2Str(TCPMinTimeout);
      MaxTimeout.Caption := Int2Str(TCPMaxTimeout);
      MaxConnections.Caption := Int2Str(TCPMaxConnections);
      ActiveOpens.Caption := Int2Str(TCPActiveOpens);
      PassiveOpens.Caption := Int2Str(TCPPassiveOpens);
      FailedConnects.Caption := Int2Str(TCPFailedConnects);
      ResetConnects.Caption := Int2Str(TCPResetConnects);
      CurrentConnects.Caption := Int2Str(TCPCurrentConnects);
      ReceivedSegments.Caption := Int2Str(TCPReceivedSegments);
      SentSegments.Caption := Int2Str(TCPSentSegments);
      ResentSegments.Caption := Int2Str(TCPResentSegments);
      ErrorsReceived.Caption := Int2Str(TCPErrorsReceived);
      SentSegsReset.Caption := Int2Str(TCPSentSegsReset);
      CumulativeConnects.Caption := Int2Str(TCPCumulativeConnects);
    end;
end;


end.

